//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern double BBLength        = 20;
extern int    BBMaMethod      = 0;
extern int    BBPrice         = 0;
extern double Deviation       = 2.0;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double UpH[];
double DnH[]; 
double NuH[];
double upper[];
double lower[]; 
double trend[];

//
//
//
//
//


int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,UpH);    SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnH);    SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,NuH);    SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,upper);
      SetIndexBuffer(4,lower);
      SetIndexBuffer(5,trend);
         
   IndicatorShortName("Bollinger Bicolor");
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      double StdDev  = iStdDev(NULL,0,BBLength,0,BBMaMethod,BBPrice,i);
      double ma      = iMA(NULL,0,BBLength,0,BBMaMethod,BBPrice,i);
             upper[i] = ma + (StdDev*Deviation);
             lower[i] = ma - (StdDev*Deviation);
      
             //
             //
             //
             //
             //
             
             UpH[i]   = EMPTY_VALUE;
             DnH[i]   = EMPTY_VALUE;
             NuH[i]   = EMPTY_VALUE;
             trend[i] = 0; 
         
	          if ( upper[i] > upper[i+1] && lower[i] < lower[i+1])                                                      trend[i] = 1; 
	          if ( upper[i] < upper[i+1] && lower[i] > lower[i+1])                                                      trend[i] =-1;
	          if ((upper[i] < upper[i+1] && lower[i] < lower[i+1]) || (upper[i] > upper[i+1] && lower[i] > lower[i+1])) trend[i] = 0; 
	          if (trend[i] == 1) UpH[i] = 1;
             if (trend[i] ==-1) DnH[i] = 1;
             if (trend[i] == 0) NuH[i] = 1;
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     {
        if (trend[whichBar] == 1)                          doAlert(whichBar,"Expanding");
        if (trend[whichBar] ==-1)                          doAlert(whichBar,"Constricting");
        if (trend[whichBar] == 0 && trend[whichBar+1]== 1) doAlert(whichBar,"Neutral from Expanding");
        if (trend[whichBar] ==-0 && trend[whichBar+1]==-1) doAlert(whichBar,"Neutral from Constricting");
     }              
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Band Bicolor ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Band Bicolor "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      